/* Toda vez que for acrescentado ou retirado um bloco deve ser alterado tambm o bloco 9,
   referente a totalizao dos blocos do livro eltrnico.  */
IF EXISTS (SELECT
              *
           FROM
              SYSOBJECTS O, SYSUSERS U
           WHERE
              O.NAME = 'ARQUIVO_DIGITAL' AND
              TYPE   = 'P' 		 AND
              U.UID  = O.UID             AND
              U.NAME = USER)

DROP PROCEDURE ARQUIVO_DIGITAL  
GO

CREATE PROCEDURE ARQUIVO_DIGITAL
   @P_CDIMPOSTO     VARCHAR(02),
   @P_CDEMPRESA     VARCHAR(02),
   @P_CDINSCESTA    VARCHAR(14),
   @P_DTINICIAL     DATETIME,
   @P_DTFINAL       DATETIME,
   @P_TIPO          VARCHAR(4000),
   @P_FINALIDADE    VARCHAR(4000),
   @P_INDESCRITU    VARCHAR(4000),
   @P_IDCENTRAL     VARCHAR(4000),
   @P_REGISTRO      VARCHAR(4000),
   @P_CDINSCMUNIC   VARCHAR(4000),
   @P_NRSEQARQMAG   VARCHAR(4000)

AS
 DECLARE  @V_CONTGERA     NUMERIC;
 DECLARE  @V_CONTREGA     NUMERIC;
 DECLARE  @V_REGAAAAA     NUMERIC;
 DECLARE  @V_CONTREGB     NUMERIC;
 DECLARE  @V_CONTREGC     NUMERIC;
 DECLARE  @V_CONTREGD     NUMERIC;
 DECLARE  @V_CONTREGE     NUMERIC;
 DECLARE  @V_CONTREGH     NUMERIC;
 DECLARE  @V_CONTREG8     NUMERIC;
 DECLARE  @V_CONTREG9     NUMERIC;
 DECLARE  @V_NOVO_CODIGO  VARCHAR(4000);
 DECLARE  @V_SEQUENCIAL   VARCHAR(4000);

BEGIN
   /* sequencial para gerao do livro eletrnico */
   SET  @V_SEQUENCIAL = @P_NRSEQARQMAG;
----------------------------------------------------  /* ABERTURA */  -------------------------------------------------
   SET @V_CONTREGA = 0;
   EXEC ARQDIGITAL_INICIO @P_CDIMPOSTO, @P_CDEMPRESA,@P_CDINSCESTA,@P_DTINICIAL,@P_DTFINAL,@P_TIPO,@P_FINALIDADE,@P_INDESCRITU,@V_SEQUENCIAL,@P_IDCENTRAL,@V_CONTREGA;
----------------------------------------------------  /* REGISTRO A */   ---------------------------------------------
   SET @V_REGAAAAA = 0;
   EXEC ARQDIGITAL_BLCA @P_CDEMPRESA, @V_SEQUENCIAL, @V_REGAAAAA;
----------------------------------------------------  /* REGISTRO B */   ---------------------------------------------
   IF SUBSTRING(@P_REGISTRO,1,1) = 'S' BEGIN
      SET @V_CONTREGB = 0;
      EXEC ARQDIGITAL_BLOCOB @P_CDIMPOSTO, @P_CDEMPRESA, @P_CDINSCMUNIC, @P_DTINICIAL, @P_DTFINAL, @V_SEQUENCIAL, @V_CONTREGB;
   END;
----------------------------------------------------  /* REGISTRO C */   ---------------------------------------------
   IF SUBSTRING(@P_REGISTRO,2,1) = 'S' BEGIN
      SET @V_CONTREGC = 0;
      EXEC ARQDIGITAL_BLOCOC @P_CDIMPOSTO, @P_CDEMPRESA, @P_CDINSCESTA, @P_DTINICIAL, @P_DTFINAL, @V_SEQUENCIAL, @V_CONTREGC;
   END;
----------------------------------------------------  /* REGISTRO D */   ---------------------------------------------
   IF SUBSTRING(@P_REGISTRO,3,1) = 'S' BEGIN
      SET @V_CONTREGD = 0;
      EXEC ARQDIGITAL_BLOCOD @P_CDIMPOSTO, @P_CDEMPRESA, @P_CDINSCESTA, @P_DTINICIAL, @P_DTFINAL, @V_SEQUENCIAL, @V_CONTREGD;
   END;
----------------------------------------------------  /* REGISTRO E */   ---------------------------------------------
   IF SUBSTRING(@P_REGISTRO,4,1) = 'S' BEGIN
      SET @V_CONTREGE = 0;
      EXEC ARQDIGITAL_BLOCOE @P_CDIMPOSTO, @P_CDEMPRESA, @P_CDINSCESTA, @P_DTINICIAL, @P_DTFINAL, @V_SEQUENCIAL, @V_CONTREGE;
   END;
---------------------------------------------------- /*  REGISTRO H  */ -----------------------------------------------
   IF SUBSTRING(@P_REGISTRO,5,1) = 'S' BEGIN
      SET @V_CONTREGH = 0;
      EXEC ARQDIGITAL_BLOCOH @P_CDIMPOSTO, @P_CDEMPRESA, @P_CDINSCESTA, @P_DTINICIAL, @P_DTFINAL, @V_SEQUENCIAL, @V_CONTREGH;
   END;

----------------------------------------------------  /*  REGISTRO 9  */  --------------------------------------------
   /* 5811 */
   SET @V_CONTREG8 = 0;
   EXEC ARQDIGITAL_BLOCO8 @P_CDEMPRESA,@V_SEQUENCIAL, @V_CONTREG8;

----------------------------------------------------  /*  REGISTRO 8  */  --------------------------------------------
   /* 5807 */
   SET @V_CONTREG9 = 0;
   EXEC ARQDIGITAL_BLOCO9 @V_CONTREGA,@V_CONTREGB,@V_CONTREGC,@V_CONTREGD,@V_CONTREGE,@V_CONTREGH,@V_SEQUENCIAL, @V_CONTREG9;

-------------------------------------   /* ENCERRAMENTO TOTAL DO BLOCO */ ---------------------------------------------

   SET @V_CONTGERA = ISNULL(@V_CONTREGA,0) + ISNULL(@V_REGAAAAA,0) + ISNULL(@V_CONTREGB,0) + ISNULL(@V_CONTREGC,0) + ISNULL(@V_CONTREGD,0) + ISNULL(@V_CONTREGE,0) + ISNULL(@V_CONTREGH,0) + ISNULL(@V_CONTREG8,0) + ISNULL(@V_CONTREG9,0);
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     ('70'+ RIGHT(REPLICATE('0', 8)+ RTRIM(@V_CONTREG9), 8), '|9999'+ '|' +RTRIM(@V_CONTGERA)+ '|',  @V_SEQUENCIAL);

END
GO

-- VERSAO --
EXEC ATUVEROBJ 'ARQUIVO_DIGITAL','5.05.008';
GO

